//Playstation 2 Utility
//
//Converts NTSC<->PAL Video Modes
//
//Original source code written by Spootnik(them@clanwho.com)
//based on information gathered from posts by gokun of the ps2ownz.com forums
//
//This version does not include the Y-Fix as it is still being researched
//
//
//Source code may be freely modified and distributed, just please give credit where credit is due

#include <stdio.h>

#define BLOCKSIZE 1000000

int main(int argc, char * argv[]) {
	FILE *binfile;
	int readcount = 1;
	char read[BLOCKSIZE];
	int counter=0;
	int counter2=0;
	int changemode = 0;
	int bytecount = 1;
	int bytecount2 = 1;
	char read2[1];
	char binread[20];
	if(argc != 3) {
		printf("Invalid Usage, program should be used as follows....\nntsconv -n somegame.bin\n-n is to convert to NTSC\n-p is to convert to PAL\n");
		return 0;
	}
	if(argv[1][1] == 'n') changemode = 1;
	else if(argv[1][1] == 'p') changemode = 2;
	else {
		printf("Invalid Usage, program should be used as follows....\nntsconv -n somegame.bin\n-n is to convert to NTSC\n-p is to convert to PAL\n");
		return 0;
	}
	binfile = fopen(argv[2], "rb+");
	if(binfile==NULL) {
		printf("Error, file could not be opened\n");
		return 0;
	}
	printf("Working, Please Wait, each \".\" represents 1mb of file processed.\n");
	do {
		//printf("Cycle\n");
		fseek(binfile, bytecount, SEEK_SET);
		if(bytecount >= bytecount2 + 1000000){
			bytecount2 = bytecount2 + 1000000;
			printf(".");
		}
		read[0] = '\0';
		readcount = fread(read, sizeof (char), BLOCKSIZE, binfile);
		read[readcount] = '\0';
		if(readcount == 0) break;
		for(counter=0; counter < readcount; counter++){
			if(read[counter]==36) {
				if(read[counter-3]==1) {
					//printf("found a 1");
					for(counter2 = 0; counter2 < 7; counter2++) {
						binread[counter2] = read[counter+counter2-2];
					}
					//fread(binread, sizeof( char ), 7, binfile);
					if(binread[0]==0 && binread[1]==5 && binread[2]==36 && binread[3]==2 && binread[4]==0 && binread[5]==6 && binread[6]==36) {
						if(changemode == 2) {
							if (fseek(binfile, bytecount+counter+1, SEEK_SET) == 0) {
								printf("Found NTSC Hex.....Changing To PAL\n");
								read2[0] = 03;
								fwrite(read2, sizeof (char), 1, binfile);
								//bytecount = bytecount + counter + 1;
								//break;
							}
							else printf("Seek Error, E-Mail pertinent details to them@clanwho.com\n");
						} else printf("Found NTSC Hex.....But leaving it alone\n");
					}
					else if(binread[0]==0 && binread[1]==5 && binread[2]==36 && binread[3]==3 && binread[4]==0 && binread[5]==6 && binread[6]==36) {
						if(changemode == 1) {
							if (fseek(binfile, bytecount+counter+1, SEEK_SET) == 0) {
								printf("Found PAL Hex.....Changing To NTSC\n");
								read2[0] = 02;
								fwrite(read2, sizeof (char), 1, binfile);
								//bytecount = bytecount + counter + 1;
								//break;
							}
							else printf("Seek Error, E-Mail pertinent details to them@clanwho.com\n");
						} else printf("Found PAL Hex.....But leaving it alone\n");
					}
				}
			} //else fseek(binfile, bytecount+1, SEEK_SET);
			else if(read[counter]=='V' || read[counter]=='v') {
				//printf("Found a V");
				//fread(binread, sizeof( char ), 11, binfile);
				for(counter2 = 0; counter2 < 10; counter2++) {
					binread[counter2] = read[counter+counter2+1];
					if(binread[counter2] == 'P' || binread[counter2] == 'p') break;
					if(binread[counter2] == 'N' || binread[counter2] == 'n') break;
				}
				//binread[12] = '\0';
				if((binread[0]=='M' || binread[0]=='m') && (binread[1]=='O' || binread[1]=='o') && (binread[2]=='D' || binread[2]=='d') && (binread[3]=='E' || binread[3]=='e')) {
					if(binread[counter2] == 'N')
					{
						if(changemode == 2) {
							if (fseek(binfile, bytecount+counter+counter2+1, SEEK_SET) == 0) 
							{
								printf("Found VMODE Set to NTSC.....Changing To PAL\n");
								fwrite("PAL", sizeof (char), 3, binfile);
								read2[0] = 00;
								fwrite(read2, sizeof (char), 1, binfile);
								//bytecount = bytecount + counter + 1;
								//break;
							}
							else printf("Seek Error, E-Mail pertinent details to them@clanwho.com\n");
						} 
						else printf("Found VMODE Set to NTSC....But leaving it alone\n");
					}
					binread[10] = '\0';
					if(binread[counter2] == 'P')
					{
						if(changemode == 1) {
							if (fseek (binfile, bytecount+counter+counter2+1, SEEK_SET) == 0) 
							{
								printf("Found VMODE Set to PAL.....Changing To NTSC\n");
								fwrite("NTSC", sizeof (char), 4, binfile);
								//bytecount = bytecount + counter + 1;
							}
							else printf("Seek Error, E-Mail pertinent details to them@clanwho.com\n");
						}
						else printf("Found VMODE Set to PAL....But leaving it alone\n");
					}
				}
			}
		} 
		bytecount = bytecount + counter;
	} while(readcount+64 == BLOCKSIZE || readcount != counter);
	fclose(binfile);
	printf("Done Converting File.\n\nHave Fun!!!!\n-Spootnik (them@clanwho.com)\n");
	return 0;
}
